import { Component, OnInit } from '@angular/core';
import { FormControl, FormGroup, Validators } from '@angular/forms';
import { NgbModal } from '@ng-bootstrap/ng-bootstrap';
import { TranslateService } from '@ngx-translate/core';
import { NgxSpinnerService } from 'ngx-spinner';
import { ToastrService } from 'ngx-toastr';
import { EmploymentServiceType } from '../../models/employment-service-type';
import { Users } from '../../models/users/user';
import { UserPages } from '../../models/users/userPages';
import { EmploymentServiceTypeService } from '../../shared/services/employment-service-type.service';
import { PaginationService } from '../../shared/services/pagination.service';

import Swal from 'sweetalert2';

@Component({
  selector: 'app-employment-service-type',
  templateUrl: './employment-service-type.component.html',
  styleUrls: ['./employment-service-type.component.scss']
})
export class EmploymentServiceTypeComponent implements OnInit {
  private token!: string
  private alertMessage!: string;
  private isShowParentSelection: boolean = true;
  private selectedEmploymentServiceType: any = [];
  private startIndex!: number;
  private fetchRecord!: number;
  private skip: number = 0;
  private take: number = 15;
  private activePage: number = 1;
  private count: number = 0;

  public user: Users = new Users();
  public title!: string;
  public displayColumns = ["id", "name", "Action"];
  public employmentServiceTypes: EmploymentServiceType[] = new Array<EmploymentServiceType>();
  public employmentServiceType: any = new EmploymentServiceType();
  public paginate: any;
  public _userPagePermission: UserPages[] = new Array<UserPages>();
  public isReadPermission!: boolean;
  public isWritePermission!: boolean;
  public isEditPermission!: boolean;
  public isDeletePermission!: boolean;


  constructor(
    private spinnerService: NgxSpinnerService,
    private toastrService: ToastrService,
    private paginationService: PaginationService,
    private employmentServiceTypeService: EmploymentServiceTypeService,
    private translate: TranslateService,
    private modalService: NgbModal
  ) {
    translate.setDefaultLang('en');
    if (sessionStorage.getItem("PagePermission") && JSON.parse(sessionStorage.getItem("PagePermission") ?? 'null').length > 0) {
      this._userPagePermission = JSON.parse(sessionStorage.getItem("PagePermission") ?? 'null') as UserPages[];
      let ind = this._userPagePermission.findIndex(c => c.name == 'employmentServiceType');
      if (ind >= 0) {
        let roleId = JSON.parse(sessionStorage.getItem("Credential") ?? 'null').userRole.roleId;
        this.isReadPermission = (roleId == 1) ? true : this._userPagePermission[ind].readPermission;
        this.isWritePermission = (roleId == 1) ? true : this._userPagePermission[ind].writePermission;
        this.isEditPermission = (roleId == 1) ? true : this._userPagePermission[ind].editPermission;
        this.isDeletePermission = (roleId == 1) ? true : this._userPagePermission[ind].deletePermission;
      }
    } else {
      let roleId = JSON.parse(sessionStorage.getItem("Credential") ?? 'null').userRole.roleId;
      this.isReadPermission = (roleId == 1) ? true : false;
      this.isWritePermission = (roleId == 1) ? true : false;
      this.isEditPermission = (roleId == 1) ? true : false;
      this.isDeletePermission = (roleId == 1) ? true : false;
    }
  }

  async ngOnInit() {
    let lang = localStorage.getItem("selectedLanguage")!;;
    this.translate.use(lang);
    this.token = sessionStorage.getItem("SessionToken")!;
    await this.setPage(1);
  }

  employmentServiceTypeform: FormGroup = new FormGroup({
    'name': new FormControl('', Validators.required),
  });

  public async setPage(pageNumber: number) {
    if (pageNumber > 0) {
      this.activePage = pageNumber;
      this.startIndex = (this.take * (this.activePage - 1));
      this.fetchRecord = this.take;
      this.skip = this.startIndex;
      await this.getEmploymentServiceType();
    }
  }

  public async getEmploymentServiceType() {
    try {
      this.spinnerService.show();
      let res = await this.employmentServiceTypeService.getEmploymentServiceType(this.startIndex, this.fetchRecord, this.token);
      if (res && res.status == 200) {
        this.employmentServiceTypes = res.recordList;

        this.count = res.totalRecords;
        this.paginate = this.paginationService.getPager(res.totalRecords, +this.activePage, this.take);
      }
      this.spinnerService.hide();
    } catch (error: any) {
      this.spinnerService.hide();
      this.alertMessage = error;
      if (error?.message) {
        this.alertMessage = error.message
      }
      if (error?.error && error.error.message) {
        this.alertMessage = error.error.message
      }
      if (error?.error && error.error.error && error.error.error.functionErrorMessage) {
        this.alertMessage = error.error.error.functionErrorMessage
      }
      this.toastrService.error(this.alertMessage)
    }
  }

  public async insertEmploymentType() {
    try {
      if (this.employmentServiceTypeform.valid) {
        this.spinnerService.show();
        if (this.employmentServiceType.id) {
          let id = this.employmentServiceType.id;
          this.employmentServiceType = this.employmentServiceTypeform.value;
          this.employmentServiceType.id = id;
          let res = await this.employmentServiceTypeService.updateEmploymentServiceType(this.employmentServiceType.id, this.employmentServiceType.name, this.token);
          if (res && res.status == 200) {
            this.modalService.dismissAll();
            this.spinnerService.hide();
            await this.getEmploymentServiceType();
          }
        }
        else {
          this.employmentServiceType = this.employmentServiceTypeform.value;
          let res = await this.employmentServiceTypeService.insertEmploymentServiceType(this.employmentServiceType.name, this.token);
          if (res && res.status == 200) {
            this.modalService.dismissAll();
            await this.getEmploymentServiceType();
          }
        }
        this.spinnerService.hide();
      } else {
        Object.keys(this.employmentServiceTypeform.controls).forEach(key => {
          this.employmentServiceTypeform.controls[key].markAsTouched();
        });
      }
    } catch (error: any) {
      this.spinnerService.hide();
      this.alertMessage = error;
      if (error?.message) {
        this.alertMessage = error.message
      }
      if (error?.error && error.error.message) {
        this.alertMessage = error.error.message
      }
      if (error?.error && error.error.error && error.error.error.functionErrorMessage) {
        this.alertMessage = error.error.error.functionErrorMessage
      }
      this.toastrService.error(this.alertMessage);
    }
  }

  public changeStatus(employmentServiceType: EmploymentServiceType) {
    let active = employmentServiceType.isActive ? "InActive" : "Active"
    Swal.fire({
      title: 'Are you sure?',
      text: "You want " + active + " this Employment Service Type",
      icon: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#a927f9',
      cancelButtonColor: '#ddd',
      confirmButtonText: 'Yes,' + active + ' it!'
    }).then(async (result: { isConfirmed: any; }) => {
      if (result.isConfirmed) {
        try {
          this.spinnerService.show();
          let res = await this.employmentServiceTypeService.activeInactiveEmploymentServiceType(employmentServiceType.id, employmentServiceType.isActive, this.token);
          if (res && res.status == 200) {
            this.getEmploymentServiceType();
            Swal.fire(
              active,
              'Successfully ' + active + ' Employment Service Type',
              'success'
            )
            const modalContent = document.querySelector('.swal2-container');
            sessionStorage.getItem('dark-mode') == 'dark-only' ? modalContent!.classList.add('dark-only-modal') : modalContent!.classList.remove('dark-only-modal')
          }
          this.spinnerService.hide();
        } catch (error: any) {
          this.spinnerService.hide();
          this.alertMessage = error;
          if (error?.message) {
            this.alertMessage = error.message
          }
          if (error?.error && error.error.message) {
            this.alertMessage = error.error.message
          }
          if (error?.error && error.error.error && error.error.error.functionErrorMessage) {
            this.alertMessage = error.error.error.functionErrorMessage
          }
          this.toastrService.error(this.alertMessage);
        }
      }
      else {
        employmentServiceType.isActive = !employmentServiceType.isActive
      }
    })
    const modalContent = document.querySelector('.swal2-container');
    sessionStorage.getItem('dark-mode') == 'dark-only' ? modalContent!.classList.add('dark-only-modal') : modalContent!.classList.remove('dark-only-modal')
  }

  public modalOpen(basicmodal: any) {
    // this.modalService.open(basicmodal);
    this.modalService.open(basicmodal, { windowClass: 'custom-modal' });
    if (sessionStorage.getItem('dark-mode') == 'dark-only') {
      const modalContent = document.querySelector('.custom-modal .modal-content');
      modalContent!.classList.add('dark-only-modal')
    }
    else {
      const modalContent = document.querySelector('.custom-modal .modal-content');
      modalContent!.classList.remove('dark-only-modal')
    }
    this.title = "Insert Service Employment Type";
    this.employmentServiceType = new EmploymentServiceType();
    this.isShowParentSelection = true;
    this.selectedEmploymentServiceType = this.employmentServiceTypes;
    this.employmentServiceTypeform.reset();
  }

  public editDialog(element: EmploymentServiceType, basicmodal: any) {
    this.title = "Edit Service Employment Type"
    this.employmentServiceType = new EmploymentServiceType();
    this.employmentServiceType = element;
    this.employmentServiceTypeform.setValue({
      "name": this.employmentServiceType.name
    })
    // this.modalService.open(basicmodal);
    this.modalService.open(basicmodal, { windowClass: 'custom-modal' });
    if (sessionStorage.getItem('dark-mode') == 'dark-only') {
      const modalContent = document.querySelector('.custom-modal .modal-content');
      modalContent!.classList.add('dark-only-modal')
    }
    else {
      const modalContent = document.querySelector('.custom-modal .modal-content');
      modalContent!.classList.remove('dark-only-modal')
    }
    this.selectedEmploymentServiceType = this.employmentServiceTypes.filter((c: any) => c.id != element.id);
  }

  public cancelUser() {
    this.user = new Users();
    this.modalService.dismissAll();
  }

}
